#include <stdio.h>
#include <string.h>
#include "kocky.h"
#include "tetris.h"

int MozeKocka(THra *Hra, int co, int x, int y) { // ci v hre Hra moze byt kocka co na suradniciach x,y
  int i,j;
  if (y<0) return 0;
  for (i=0;i<4;i++) for (j=0;j<4;j++) if (KOCKA[co][i][j]!='.') {
    if ((y+j)>=(Hra->C)) return 0;
    if (Hra->Plan[x+i][y+j]) return 0;
  }
  return 1;
}

int KonciKocka(THra *Hra, int co, int x, int y) { // ci tam kocka moze skoncit (netestuje, ci tam moze byt)
  int i,j;
  for (i=0;i<4;i++) for (j=0;j<4;j++) if (KOCKA[co][i][j]!='.') if (KOCKA[co][i+1][j]=='.') 
    if (Hra->Plan[x+i+1][y+j]) return 1;
  return 0;
}

void NajdiTahy(THra *Hra, int *POCET, TTah *TAHY){
  int K,k,r,c,i,qs,qf,kk,rr,cc,pocet;
  char bol[4][50][25],last[4][50][25];
  char Q[4*50*25][3];

  pocet=0;
  K=Hra->this/4; 
  bzero(bol,sizeof(bol)); 
  qs=0; qf=1; Q[qs][0]=Hra->this%4; Q[qs][1]=Q[qs][2]=0;  
  bol[Hra->this%4][0][0]=1; last[Hra->this%4][0][0]='-';
  while (qs!=qf){
    k=Q[qs][0]; r=Q[qs][1]; c=Q[qs][2]; qs++;
    // pozrieme ci nie je koncova, ak ano pridat do zoznamu (dlzka=bol[] - 1)
    if (KonciKocka(Hra,4*K+k,r,c)){
      i=bol[k][r][c]-2; kk=k; rr=r; cc=c;
      TAHY[pocet][i+1]=0;
      while (i>=0){ 
        TAHY[pocet][i]=last[kk][rr][cc];
        switch (last[kk][rr][cc]){
          case 'L': cc++; break;
          case 'R': cc--; break;
          case 'D': rr--; break;
          case 'T': kk=(kk+3)%4; break;
        }
        i--;
      }
      pocet++;
    }
    // otocit
    if (MozeKocka(Hra,4*K+((k+1)%4),r,c)) if (!bol[(k+1)%4][r][c]) {
      bol[(k+1)%4][r][c]=bol[k][r][c]+1; last[(k+1)%4][r][c]='T'; 
      Q[qf][0]=(k+1)%4; Q[qf][1]=r; Q[qf][2]=c; qf++;
    }
    // dolava 
    if (MozeKocka(Hra,4*K+k,r,c-1)) if (!bol[k][r][c-1]) {
      bol[k][r][c-1]=bol[k][r][c]+1; last[k][r][c-1]='L'; 
      Q[qf][0]=k; Q[qf][1]=r; Q[qf][2]=c-1; qf++;
    }
    // doprava 
    if (MozeKocka(Hra,4*K+k,r,c+1)) if (!bol[k][r][c+1]) {
      bol[k][r][c+1]=bol[k][r][c]+1; last[k][r][c+1]='R'; 
      Q[qf][0]=k; Q[qf][1]=r; Q[qf][2]=c+1; qf++;
    }
    // dodola
    if (MozeKocka(Hra,4*K+k,r+1,c)) if (!bol[k][r+1][c]) {
      bol[k][r+1][c]=bol[k][r][c]+1; last[k][r+1][c]='D'; 
      Q[qf][0]=k; Q[qf][1]=r+1; Q[qf][2]=c; qf++;
    }
  }
  *POCET=pocet;
//  Tahy=(char **)malloc((pocet+1)*(sizeof(char *)));
//  for (i=0;i<pocet;i++) Tahy[i]=(char *)malloc(strlen(tahy[i])+2);
//  for (i=0;i<pocet;i++) strcpy(Tahy[i],tahy[i]);
}

void SpravTah(THra *Hra, char *tah){
  int tt,ok,kr,kc,i,j,nju;
  for (tt=0;tt<(int)strlen(tah);tt++) {
    switch (tah[tt]){
      case 'L':
        ok=1;
        for (i=0;i<4;i++) for (j=0;j<4;j++) if ((Hra->thisc)+j-1<0) if (KOCKA[Hra->this][i][j]!='.') ok=0;
        Hra->thisc-=ok;
      break;
      case 'R':
        ok=1;
        for (i=0;i<4;i++) for (j=0;j<4;j++) if ((Hra->thisc)+j+1>=Hra->C) if (KOCKA[Hra->this][i][j]!='.') ok=0;
        Hra->thisc+=ok;
      break;
      case 'T':
        ok=1; nju=4*(Hra->this/4)+((Hra->this%4)+1)%4;
        for (i=0;i<4;i++) for (j=0;j<4;j++)
          if (KOCKA[nju][i][j]!='.') if (Hra->Plan[(Hra->thisr)+i][(Hra->thisc)+j]) ok=0;
        if (ok) Hra->this=nju;
      break;
      case 'D':
        ok=1;
        for (i=0;i<4;i++) for (j=0;j<4;j++) if (KOCKA[Hra->this][i][j]!='.') if (KOCKA[Hra->this][i+1][j]=='.')
          if (Hra->Plan[Hra->thisr+i+1][Hra->thisc+j]) ok=0;
        Hra->thisr+=ok;
      break;
    }
  }
  // padame
  ok=1;
  for (i=0;i<4;i++) for (j=0;j<4;j++) if (KOCKA[Hra->this][i][j]!='.') if (KOCKA[Hra->this][i+1][j]=='.')
    if (Hra->Plan[(Hra->thisr)+i+1][(Hra->thisc)+j]) ok=0;
  while (ok){
    Hra->thisr++; ok=1;
    for (i=0;i<4;i++) for (j=0;j<4;j++) if (KOCKA[Hra->this][i][j]!='.') if (KOCKA[Hra->this][i+1][j]=='.')
      if (Hra->Plan[(Hra->thisr)+i+1][(Hra->thisc)+j]) ok=0;
  }

  for (i=0;i<4;i++) for (j=0;j<4;j++)
    if (KOCKA[Hra->this][i][j]!='.') Hra->Plan[(Hra->thisr)+i][(Hra->thisc)+j]=KOCKA[Hra->this][i][j];

  // odobrat riadky pridat body
  for (kr=0,kc=0;kr<Hra->R;kr++) {
    ok=1; for (i=0;i<Hra->C;i++) if (!Hra->Plan[kr][i]) { ok=0; break; }
    if (ok){
      kc++;
      for (i=kr-1;i>=0;i--) for (j=0;j<Hra->C;j++) Hra->Plan[i+1][j]=Hra->Plan[i][j];
      for (j=0;j<Hra->C;j++) Hra->Plan[0][j]=0;
    }
  }
  Hra->lines+=kc; Hra->score+=kc*kc;
  Hra->thisr=Hra->thisc=0;
  Hra->this=Hra->next; // toto sa vyuzije len pred backtrackom, inak sa this a next citaju zo vstupu
}

int HodnotHru(THra *Hra){
  int i,j;
  int VALUE=0;
  int vyska[30];
  for (j=0;j<Hra->C;j++) {
    i=0; while (!Hra->Plan[i][j]) i++; vyska[j]=(Hra->R)-i;
    if (i<4) return -10000; // lost
    while (i<Hra->R) {
      if (!Hra->Plan[i][j]) VALUE-=30;
      i++;
    }
  }
  VALUE-=vyska[0]*vyska[0]*3/4;
  VALUE-=vyska[Hra->C-1]*vyska[Hra->C-1]*3/4;
  for (j=1;j<Hra->C-1;j++) VALUE-=vyska[j]*vyska[j];
  VALUE+=100*Hra->score;
  // este par bodov dole za jamy sirky 1
  for (i=0;i<Hra->R;i++) for (j=1;j<Hra->C-1;j++) 
    if (!Hra->Plan[i][j]) if (Hra->Plan[i][j-1]) if (Hra->Plan[i][j+1])
      VALUE-=10;
  for (i=0;i<Hra->R;i++) if (!Hra->Plan[i][0]) if (Hra->Plan[i][1])
    VALUE-=10;
  for (i=0;i<Hra->R;i++) if (!Hra->Plan[i][Hra->C-1]) if(Hra->Plan[i][Hra->C-2])
    VALUE-=10;
  return VALUE;
}

