#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <time.h>
#include "kocky.h"
#include "initX.h"

typedef struct { char Plan[50][25]; int R,C; int this,next; int score,lines,moves; int thisr,thisc; } THra;

mColor KockaColor[] = {mRGB(255,0,0), mRGB(0,255,0), mRGB(0,0,255), mRGB(255,255,0),
  mRGB(255,0,255), mRGB(0,255,255), mRGB(255,0,100), 
  
  mRGB(160,0,0), mRGB(0,160,0), mRGB(0,0,160), mRGB(160,160,0),
  mRGB(160,0,160), mRGB(0,160,160), mRGB(160,0,66) };
//  mRGB(255,100,100), mRGB(100,255,0), mRGB(0,255,100), mRGB(100,255,100),
//  mRGB(100,0,255), mRGB(0,100,255), mRGB(100,100,255) };
mWindow *W;
Pixmap P;
mColor palette[256];
int width=400, height=600;
XEvent e;

int child;
THra Hra;
struct timeval zaciatok,koniec;
double elapsed=0.0;
char nazov_kocky[7]={'o','j','l','z','s','i','t'};
int SILENT=1;

void Kresli(THra *Hra){
  int i,j; 
  char buf[100];

  // sachta 
  for (i=0;i<Hra->R;i++) for (j=0;j<Hra->C;j++) {
    if (Hra->Plan[i][j]) mSetColor(W,KockaColor[((int)Hra->Plan[i][j])-90]); else {
      if (i<4) mSetColor(W,0xaaaaaa); else mSetColor(W,0x000000);
    }
    XFillRectangle(theDisplay,P,W->theGC,1+30*j,1+30*i,28,28);
  }
  // aktualna kocka
  for (i=0;i<4;i++) for (j=0;j<4;j++) if (KOCKA[Hra->this][i][j]!='.') {
    mSetColor(W,KockaColor[((int)Hra->this/4)]); 
    XFillRectangle(theDisplay,P,W->theGC,1+30*(j+Hra->thisc),1+30*(i+Hra->thisr),28,28);
  }
  // next kocka
  for (i=0;i<4;i++) for (j=0;j<4;j++) {
    if (KOCKA[Hra->next][i][j]!='.') mSetColor(W,KockaColor[((int)Hra->next/4)]);
      else mSetColor(W,0x000000);
    XFillRectangle(theDisplay,P,W->theGC,1+30*(j+SIRKA_SACHTY+1),1+30*(i+2),28,28);
  }
  // body skore a ine haluze
  sprintf(buf,"Next:"); XDrawString(theDisplay,P,W->theGC,35+30*SIRKA_SACHTY,50,buf,strlen(buf));
  mSetColor(W,0xffffff);
  XFillRectangle(theDisplay,P,W->theGC,10+30*SIRKA_SACHTY,185,120,100);
  mSetColor(W,0x000000);
  sprintf(buf,"Skore: %d",Hra->score); XDrawString(theDisplay,P,W->theGC,10+30*SIRKA_SACHTY,200,buf,strlen(buf));
  sprintf(buf,"Riadky: %d",Hra->lines); XDrawString(theDisplay,P,W->theGC,10+30*SIRKA_SACHTY,215,buf,strlen(buf));
  sprintf(buf,"Kocky: %d",Hra->moves); XDrawString(theDisplay,P,W->theGC,10+30*SIRKA_SACHTY,230,buf,strlen(buf));
  sprintf(buf,"Cas: %.2fs",elapsed); XDrawString(theDisplay,P,W->theGC,10+30*SIRKA_SACHTY,245,buf,strlen(buf));

  mSetBackgroundPixmap(W,P);
  XFlush(theDisplay);
  usleep(20000);
}

void NovaHra(THra *Hra){
  int i;
  bzero(Hra->Plan,sizeof(Hra->Plan));
  Hra->R=HLBKA_SACHTY; Hra->C=SIRKA_SACHTY; for (i=0;i<Hra->C;i++) Hra->Plan[Hra->R][i]='x';
  srand(time(NULL));
  Hra->this=(rand()%7)*4;
  Hra->next=(rand()%7)*4;
  Hra->score=Hra->lines=Hra->moves=0;
  Hra->thisr=Hra->thisc=0;
  
  printf("nova hra %d %d\n",Hra->R,Hra->C);
  
  Kresli(Hra);
}

int JeKoniecHry(THra *Hra){ 
  int i,j;
  for (i=0;i<4;i++) for (j=0;j<Hra->C;j++) if (Hra->Plan[i][j]) return 1;
  return 0;
}

void KoniecHry(THra *Hra){
  double bubu;
  
  gettimeofday(&koniec,NULL);
  bubu=(koniec.tv_sec-zaciatok.tv_sec); bubu+=((double)(koniec.tv_usec-zaciatok.tv_usec))/1000000.0;
  elapsed+=bubu;
  
  Hra->this=Hra->next; // aby nepisal warning ;))
  fprintf(stderr,"GAME OVER.\n");
  fprintf(stderr,"skore:%d, riadkov:%d, kociek:%d, cas:%.3f\n",Hra->score,Hra->lines,Hra->moves,elapsed);
  printf("-1 -1\n");
  wait(NULL);
  exit(0);
}

void SpracujTah(THra *Hra) {
  char tah[1000];
  int tt,kr,kc,i,j,ok,nju;
  double bubu;
  
  if (JeKoniecHry(Hra)) KoniecHry(Hra);
  gettimeofday(&zaciatok,NULL);
  printf("%d %d\n",Hra->this,Hra->next); 
  Hra->moves++;
  
  if (!fgets(tah,997,stdin)) { fprintf(stderr,"Hrac samovolne umrel :(\n"); KoniecHry(Hra); }
  
  gettimeofday(&koniec,NULL);
  bubu=(koniec.tv_sec-zaciatok.tv_sec); bubu+=((double)(koniec.tv_usec-zaciatok.tv_usec))/1000000.0;
  elapsed+=bubu;
  
  tah[strlen(tah)-1]=0;
  if (!SILENT) fprintf(stderr,"tah %d: '%s'\n",Hra->moves,tah);
  for (tt=0;tt<(int)strlen(tah);tt++) {
    switch (tah[tt]){
      case 'L': 
        ok=1; 
        for (i=0;i<4;i++) for (j=0;j<4;j++) if ((Hra->thisc)+j-1<0) if (KOCKA[Hra->this][i][j]!='.') ok=0;
        Hra->thisc-=ok;
      break;
      case 'R': 
        ok=1; 
        for (i=0;i<4;i++) for (j=0;j<4;j++) if ((Hra->thisc)+j+1>=Hra->C) if (KOCKA[Hra->this][i][j]!='.') ok=0;
        Hra->thisc+=ok;
      break;          
      case 'T': 
        ok=1; nju=4*(Hra->this/4)+((Hra->this%4)+1)%4; 
        for (i=0;i<4;i++) for (j=0;j<4;j++) 
          if (KOCKA[nju][i][j]!='.') if (Hra->Plan[(Hra->thisr)+i][(Hra->thisc)+j]) ok=0;
        if (ok) Hra->this=nju;
      break;
      case 'D':
        ok=1;
        for (i=0;i<4;i++) for (j=0;j<4;j++) if (KOCKA[Hra->this][i][j]!='.') if (KOCKA[Hra->this][i+1][j]=='.') 
          if (Hra->Plan[Hra->thisr+i+1][Hra->thisc+j]) ok=0;
        Hra->thisr+=ok;
      break;
    }
    // vykresli 
    Kresli(Hra);
  }
//  fprintf(stderr,"spracoval tah, ide padat na %d %d\n",Hra->thisr,Hra->thisc);
  // kym nie sme dole, padame
  ok=1;
  for (i=0;i<4;i++) for (j=0;j<4;j++) if (KOCKA[Hra->this][i][j]!='.') if (KOCKA[Hra->this][i+1][j]=='.') 
    if (Hra->Plan[(Hra->thisr)+i+1][(Hra->thisc)+j]) ok=0;
  while (ok){
    Hra->thisr++; ok=1;
    for (i=0;i<4;i++) for (j=0;j<4;j++) if (KOCKA[Hra->this][i][j]!='.') if (KOCKA[Hra->this][i+1][j]=='.') 
      if (Hra->Plan[(Hra->thisr)+i+1][(Hra->thisc)+j]) ok=0;
  }
//  fprintf(stderr,"dopadol na %d %d\n",Hra->thisr,Hra->thisc);
  for (i=0;i<4;i++) for (j=0;j<4;j++) 
    if (KOCKA[Hra->this][i][j]!='.') Hra->Plan[(Hra->thisr)+i][(Hra->thisc)+j]=KOCKA[Hra->this][i][j];
  
  // odobrat riadky pridat body
  for (kr=0,kc=0;kr<Hra->R;kr++) {
    ok=1; for (i=0;i<Hra->C;i++) if (!Hra->Plan[kr][i]) { ok=0; break; }
    if (ok){
      kc++; 
      for (i=kr-1;i>=0;i--) for (j=0;j<Hra->C;j++) Hra->Plan[i+1][j]=Hra->Plan[i][j];
      for (j=0;j<Hra->C;j++) Hra->Plan[0][j]=0;
    }
  }
  Hra->lines+=kc; Hra->score+=kc*kc;
  
  Hra->this=Hra->next;
  Hra->next=(rand()%7)*4;
  Hra->thisr=Hra->thisc=0;
  
  Kresli(Hra);
}	

void SpustiHraca(void) {
  int fds1[2],fds2[2];
  if (pipe(fds1)||pipe(fds2)) {
    fprintf(stderr,"Cannot launch the tested program.\n");	  
    exit(2);	  
    }
  fclose(stdin); fclose(stdout);
  child=fork();
  if (child==-1) {
    fprintf(stderr,"Cannot launch the tested program.\n");	  
    exit(2);	  
    }	  
  if (child) {
    if ((dup2(fds1[0],0)==-1)||(dup2(fds2[1],1)==-1)) {
      fprintf(stderr,"Cannot launch the tested program.\n");	  
      exit(2);	  
      }
    close(fds1[0]); close(fds1[1]); close(fds2[0]); close(fds2[1]);
    stdin = fdopen(0, "r");
    stdout = fdopen(1, "w");
    setvbuf(stdin, NULL, _IONBF, 0);
    setvbuf(stdout, NULL, _IONBF, 0);
    return;
    }	  
  if ((dup2(fds2[0],0)==-1)||(dup2(fds1[1],1)==-1)) {
    fprintf(stderr,"Cannot launch the tested program.\n");	  
    exit(2);	  
    }
  close(fds1[0]); close(fds1[1]); close(fds2[0]); close(fds2[1]);
  execl("./player","player","xyzzy",NULL);
  fprintf(stderr,"Cannot launch the tested program.\n");
  exit(2);
}

void InitGrafiky(void){
  int i,j,r,g,b;
  
  mInitX(NULL,1,1);
  for(i=0;i<256;i++) {
    r=(int)(cos(i*3.141592L/256.0L)*128)+128;
    g=(int)(cos(i*3.141592L/128.0L)*128)+128;
    b=(int)(cos(i*3.141592L/64.0L)*128)+128;
    palette[i]=mRGB(r,g,b);
  }
  palette[0]=0;

  width=30*SIRKA_SACHTY + 150;
  height=30*HLBKA_SACHTY;
  
  W=mOpenWindow(width,height,0,"PVMtris");
  P=XCreatePixmap(theDisplay,W->theWindow,width,height,theDepth);
  mSetColor(W,0xffffff);
  XFillRectangle(theDisplay,P,W->theGC,0,0,width,height);
  mSetColor(W,0x000000);
  for (i=0;i<SIRKA_SACHTY;i++) for (j=0;j<HLBKA_SACHTY;j++) XFillRectangle(theDisplay,P,W->theGC,1+30*i,1+30*j,28,28);
  mSetColor(W,0xaaaaaa);
  for (i=0;i<SIRKA_SACHTY;i++) for (j=0;j<4;j++) XFillRectangle(theDisplay,P,W->theGC,1+30*i,1+30*j,28,28);
  mSetBackgroundPixmap(W,P);
  XFlush(theDisplay);
}

int main(int argc,char **argv) {
  while (argc>1) {
    if (!strcmp(argv[argc-1],"-q")) SILENT=1;
    if (!strcmp(argv[argc-1],"-v")) SILENT=0;
    argc--;
  }
  
  SpustiHraca();
  InitGrafiky();
  NovaHra(&Hra);
  while (1) SpracujTah(&Hra);
  fprintf(stderr,"Okay!\n");
  mCloseWindow(W);
  free(W);
  return 0;
}
